<div>
    {% if owner %}
        <div class="status-form border rounded p-2">
            <div class="form-group">
                <textarea id="status-content" class="form-control" placeholder="share your mind"></textarea>
                <button id="btn-post-status" class="btn btn-primary mt-2">POST</button>
            </div>
        </div>
    {% endif %}
    <div id="status-list" class="status-list"></div>
</div>


<script>
    let count = 0;
    let status_id = null;

    const fetchUserStatusList = () => {
        $.ajax({
            method: 'GET',
            url: '{% url "members:status" %}',
            headers: {"X-CSRFToken": csrftoken},
            data: {username: '{{ member.user.username }}'},
            success: (data, textStatus) => {
                console.log('data:', data, ' status code:', textStatus);
                $('#status-list').empty();
                data.status_list.forEach(status => {
                    createStatusComponent(status)
                })
            }

        })
    };

    const createCommentComponent = (comment) => {
        const comment_owner = document.createElement('a');
        $(comment_owner).addClass('comment-owner');
        $(comment_owner).attr('href', creatreUserProfileUrl(comment.owner_username));
        $(comment_owner).text(comment.owner_username);

        const comment_date = document.createElement('span');
        $(comment_date).addClass('comment-date');
        $(comment_date).text(`(${formateDate(new Date(comment.timestamp))})`);

        const comment_content = document.createElement('p');
        $(comment_content).addClass('comment-content');
        $(comment_content).html(`${comment_owner.outerHTML} ${comment.content} ${comment_date.outerHTML}`);

        const comment_container = document.createElement('div');
        $(comment_container).addClass('comment-container');
        $(comment_container).append(comment_content);
        return comment_container;
    }

    const createStatusComponent = (status) => {
        console.log(status);

        const status_container = document.createElement('div');
        $(status_container).addClass('status-container border rounded mt-2 p-2');

        const status_content = document.createElement('p');
        $(status_content).addClass('status-content');
        $(status_content).text(status.content);

        const status_timestamp = document.createElement('span');
        $(status_timestamp).addClass('status-timestamp timestamp');
        $(status_timestamp).text(formateDate(Date.parse(status.timestamp).valueOf()));

        const status_action_container = document.createElement('div');
        $(status_action_container).addClass('status-action-container');

        const btn_edit = document.createElement('div');
        $(btn_edit).addClass('btn-edit-status');
        $(btn_edit).html('<i class="fas fa-edit"></i>');
        $(status_action_container).append(btn_edit);
        $(btn_edit).on('click', (event) => {
            status_id = status.id;
            $('#status-content').val(status.content);
        });


        const btn_delete = document.createElement('div');
        $(btn_delete).addClass('btn-delete-status');
        $(btn_delete).html('<i class="fas fa-trash-alt"></i>');
        $(status_action_container).append(btn_delete);
        $(btn_delete).on('click', () => {
            $.ajax({
                method: 'POST',
                url: '{% url "members:status" %}',
                headers: {"X-CSRFToken": csrftoken},
                data: {action: 'delete', id: status.id},
                success: () => {
                    fetchUserStatusList();
                }
            });
        });


        //---------------------------------------------------------------------------------------------------------------

        const comments_section = document.createElement('div');
        $(comments_section).addClass('comments-section mt-3');

        if (status.comments) {
            status.comments.forEach(comment => {
                const comment_container = createCommentComponent(comment);
                $(comments_section).append(comment_container);
            });
        }


        const new_comment_section = document.createElement('div');
        $(new_comment_section).addClass('new-comment-form input-group mt-2');

        const comment_control = document.createElement('input');
        $(comment_control).addClass('form-control comment-input');
        $(comment_control).attr('type', 'text');
        $(comment_control).attr('placeholder', 'comment...');


        const btn_send_comment = document.createElement('div');
        $(btn_send_comment).addClass('btn-send-comment');
        $(btn_send_comment).html('<i class="fas fa-comment"></i>');
        $(btn_send_comment).on('click', () => {
            $.ajax({
                method: 'POST',
                url: '{% url "members:comment" %}',
                headers: {"X-CSRFToken": csrftoken},
                data: {
                    action: 'create',
                    status_id: status.id,
                    username: '{{ request.user.username }}',
                    content: $(comment_control).val()
                },
                success: (data, textStatus) => {
                    if (textStatus === 'success') {
                        if (data.comment_list) {
                            $(comments_section).empty();
                            $(comment_control).val('');
                            data.comment_list.forEach(comment => {
                                const comment_container = createCommentComponent(comment);
                                $(comments_section).append(comment_container);
                            });
                        }
                    }

                }
            })
        });


        $(new_comment_section).append(comment_control);
        $(new_comment_section).append(btn_send_comment);

        $(status_container).append(status_timestamp);
        $(status_container).append(status_content);
        if (isOwner(status.owner_username)) {
            $(status_container).append(status_action_container);
        }

        $(status_container).append(comments_section);
        if (isOwner(status.owner_username) || status.can_comment) {
            $(status_container).append(new_comment_section);
        }


        $('#status-list').append(status_container);


    };

    $(document).ready(() => {
        fetchUserStatusList();

        $('#btn-post-status').on('click', () => {
            const data = {
                action: 'create',
                id: status_id,
                username: '{{ request.user.username }}',
                content: $('#status-content').val()
            };
            if (status_id) {
                data.action = 'update';
                data.id = status_id;
            } else {
                data.action = 'create';
            }

            $.ajax({
                method: 'POST',
                url: '{% url "members:status" %}',
                headers: {"X-CSRFToken": csrftoken},
                data: data,
                success: (data, textStatus) => {
                    if (textStatus === 'success') {
                        $('#status-content').val('');
                        status_id = null;
                        fetchUserStatusList();
                    }

                },
                error: (msg) => {
                    console.log(msg);
                }
            })
        })
    });
</script>



